
package de.ivu.elect.presentation.wahlausschuss.form;

import static java.util.Objects.isNull;

import java.util.List;

import javax.annotation.Nullable;

import de.ivu.elect.business.wahlausschuss.entity.Wahlausschussmitglied;
import de.ivu.elect.business.wahlausschuss.entity.WahlausschussmitgliedConstants;
import de.ivu.elect.jee.faces.Messages;
import de.ivu.elect.presentation.AbstractEntitySelectOneMenuProperty;

public class WahlausschussmitgliedSelectOneMenuProperty extends AbstractEntitySelectOneMenuProperty<Wahlausschussmitglied> {

  private final Messages messages;

  private final Wahlausschussmitglied wahlausschussmitglied;

  public WahlausschussmitgliedSelectOneMenuProperty(Messages messages, List<Wahlausschussmitglied> values, boolean hasNoSelectionItem,
      Wahlausschussmitglied wahlausschussmitglied) {
    super(values, hasNoSelectionItem);

    this.messages = messages;
    this.wahlausschussmitglied = wahlausschussmitglied;
  }

  @Override
  protected String getMessageKeyEntityEinzahl() {
    return WahlausschussmitgliedConstants.MESSAGE_KEY_VERTRETER_ID_EINZAHL;
  }

  @Nullable
  @Override
  public Wahlausschussmitglied getValue() {
    return wahlausschussmitglied.getVertreter();
  }

  @Override
  public void setValue(Wahlausschussmitglied value) {
    wahlausschussmitglied.setVertreter(value);
  }

  @Override
  public String getItemLabel(Wahlausschussmitglied item) {
    if (isNull(item)) {
      return "";
    }

    return item.getTitelNamensbestandteileFamiliennameVornameRolleGruppe(messages);
  }
}
